package ratel.crack.commom;

import com.virjar.ratel.api.rposed.IRposedHookLoadPackage;
import com.virjar.ratel.api.rposed.callbacks.RC_LoadPackage;

import java.util.HashMap;
import java.util.Map;

import ratel.crack.commom.apps.testapp.TestProcessor;

/**
 * Created by virjar on 2018/10/6.
 */

public class HookEntry implements IRposedHookLoadPackage {
    public static final String tag = "DEMO_HOOK";
    private static Map<String, Processor> processorMap = new HashMap<>();

    static {
        registerProcessor(new TestProcessor());
    }

    private static void registerProcessor(Processor processor) {
        processorMap.put(processor.packageName(), processor);
    }

    @Override
    public void handleLoadPackage(final RC_LoadPackage.LoadPackageParam lpparam) {
        Processor processor = processorMap.get(lpparam.packageName);
        if (processor == null) {
            return;
        }
        processor.handle(lpparam);
    }


}
