package ratel.crack.com.TianjinAirlines.androidApp;

import com.virjar.ratel.api.rposed.RposedHelpers;
import com.virjar.sekiro.business.api.interfaze.Action;
import com.virjar.sekiro.business.api.interfaze.AutoBind;
import com.virjar.sekiro.business.api.interfaze.RequestHandler;
import com.virjar.sekiro.business.api.interfaze.SekiroRequest;
import com.virjar.sekiro.business.api.interfaze.SekiroResponse;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import external.com.alibaba.fastjson.JSONObject;

@Action("AirItineraryReservation")
public class AirItineraryReservationHandler implements RequestHandler {

    @AutoBind(require = true)
    private String itineraryPriceIds;

    private Object _rInstance;

    private Class<?> itineraryPriceReqClazz;

    private Class<?> callbackClazz;

    public AirItineraryReservationHandler(Object _rInstance, Class<?> itineraryPriceReqClazz, Class<?> callbackClzaa) {
        this._rInstance = _rInstance;
        this.itineraryPriceReqClazz = itineraryPriceReqClazz;
        this.callbackClazz = callbackClzaa;

    }

    @Override
    public void handleRequest(SekiroRequest sekiroRequest, final SekiroResponse sekiroResponse) {
        Object o = Proxy.newProxyInstance(callbackClazz.getClassLoader(), new Class[]{callbackClazz}, new InvocationHandler() {
            @Override
            public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
                if (method.getName().equals("onRequestSuccess")) {
                    String result = RposedHelpers.getObjectField(args[0], "result");
                    sekiroResponse.success(JSONObject.parse(result));
                } else if (method.getName().equals("onRequestError")) {
                    sekiroResponse.failed(args[0].toString());
                }
                return null;
            }
        });

        Object itineraryPriceReq = RposedHelpers.newInstance(this.itineraryPriceReqClazz, itineraryPriceIds);
        RposedHelpers.callMethod(this._rInstance, "getAirItineraryReservation", itineraryPriceReq, o);
    }
}
