package ratel.crack.com.TianjinAirlines.androidApp;

import android.util.Log;

import com.virjar.ratel.api.RatelToolKit;
import com.virjar.ratel.api.rposed.RposedHelpers;
import com.virjar.sekiro.business.api.interfaze.Action;
import com.virjar.sekiro.business.api.interfaze.AutoBind;
import com.virjar.sekiro.business.api.interfaze.RequestHandler;
import com.virjar.sekiro.business.api.interfaze.SekiroRequest;
import com.virjar.sekiro.business.api.interfaze.SekiroResponse;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import external.com.alibaba.fastjson.JSONObject;

@Action("AirLowSearch")
public class AirLowSearchHandler implements RequestHandler {

    private final Object rsInstance;
    private final Class<?> callBackClazz;
    private final Class<?> getDescClazz;

    @AutoBind(require = true)
    private String origin;

    @AutoBind(require = true)
    private String destination;

    @AutoBind(require = true)
    private String departureDate;

    @AutoBind
    private String backDate;

    public AirLowSearchHandler(Object rsInstance, Class<?> getDescClazz, Class<?> callBackClazz) {
        this.rsInstance = rsInstance;
        this.callBackClazz = callBackClazz;
        this.getDescClazz = getDescClazz;
    }

    @Override
    public void handleRequest(SekiroRequest sekiroRequest, final SekiroResponse sekiroResponse) {
        String desc = (String) RposedHelpers.callStaticMethod(getDescClazz, "getImei", RatelToolKit.sContext);
        Log.i(HookEntry.TAG, "handleRequest desc: " + desc);
        Object o = Proxy.newProxyInstance(callBackClazz.getClassLoader(), new Class[]{callBackClazz}, new InvocationHandler() {
            @Override
            public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
                if (method.getName().equals("onRequestSuccess")) {
                    String result = RposedHelpers.getObjectField(args[0], "result");
                    sekiroResponse.success(JSONObject.parse(result));
                } else if (method.getName().equals("onRequestError")) {
                    sekiroResponse.failed(args[0].toString());
                }
                return null;
            }
        });
        RposedHelpers.callMethod(rsInstance, "getAirLowSearch", origin, destination, departureDate, backDate, desc, null, o);
        Log.i(HookEntry.TAG, "handleRequest: call success");
    }
}
