package ratel.crack.com.TianjinAirlines.androidApp;

import android.util.Log;

import com.virjar.ratel.api.RatelToolKit;
import com.virjar.ratel.api.rposed.RposedHelpers;
import com.virjar.sekiro.business.api.interfaze.Action;
import com.virjar.sekiro.business.api.interfaze.AutoBind;
import com.virjar.sekiro.business.api.interfaze.RequestHandler;
import com.virjar.sekiro.business.api.interfaze.SekiroRequest;
import com.virjar.sekiro.business.api.interfaze.SekiroResponse;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import java.util.ArrayList;
import java.util.List;

import external.com.alibaba.fastjson.JSONObject;

@Action("CreateReservation")
public class CreateReservationHandler implements RequestHandler {

    private Object _rInstance;

    private Class<?> createReservationReqClazz;

    private Class<?> callbackClazz;

    private final Class<?> getDescClazz;

    private Class<?> customerBeanClazz;

    private Class<?> passengerListBeanClazz;


    @AutoBind(require = true)
    private String shoppingCartId;

    @AutoBind(require = true)
    private String customerEmail;

    @AutoBind(require = true)
    private String customerFirstName;

    @AutoBind(require = true)
    private String customerLastName;

    @AutoBind(defaultValue = "")
    private String customerId;

    @AutoBind(require = true)
    private String customerMobile;

    @AutoBind(require = true)
    private String passengerBirthday;

    @AutoBind(defaultValue = "")
    private String passengerCardIssueCountry;

    @AutoBind(defaultValue = "")
    private String passengerCardValidDate;

    @AutoBind(defaultValue = "")
    private String passengerCountry;

    @AutoBind(defaultValue = "")
    private String passengerEmail;

    @AutoBind(require = true)
    private String passengerFirstName;

    @AutoBind(require = true)
    private String passengerIdNo;
    @AutoBind(defaultValue = "1")
    private String passengerIdType;
    @AutoBind(require = true)
    private String passengerLastName;
    @AutoBind(require = true)
    private String passengerMobile;
    @AutoBind(defaultValue = "ADT")
    private String passengerPassType;
    @AutoBind(require = true)
    private String passengerSex;


    public CreateReservationHandler(Object _rInstance, Class<?> createReservationReqClazz, Class<?> getDescClazz, Class<?> customerBeanClazz, Class<?> passengerListBeanClazz, Class<?> callbackClazz) {
        this._rInstance = _rInstance;
        this.createReservationReqClazz = createReservationReqClazz;
        this.getDescClazz = getDescClazz;
        this.callbackClazz = callbackClazz;
        this.customerBeanClazz = customerBeanClazz;
        this.passengerListBeanClazz = passengerListBeanClazz;
    }

    @Override
    public void handleRequest(SekiroRequest sekiroRequest, final SekiroResponse sekiroResponse) {
        try {


            Object customer = RposedHelpers.newInstance(this.customerBeanClazz);
            RposedHelpers.callMethod(customer, "setEmail", customerEmail);
            RposedHelpers.callMethod(customer, "setFirstName", customerFirstName);
            RposedHelpers.callMethod(customer, "setLastName", customerLastName);
            RposedHelpers.callMethod(customer, "setMobile", customerMobile);
            RposedHelpers.callMethod(customer, "setId", customerId);

            Object passenger = RposedHelpers.newInstance(this.passengerListBeanClazz);
            RposedHelpers.callMethod(passenger, "setBirthday", passengerBirthday);
            RposedHelpers.callMethod(passenger, "setCardIssueCountry", passengerCardIssueCountry);
            RposedHelpers.callMethod(passenger, "setCardValidDate", passengerCardValidDate);
            RposedHelpers.callMethod(passenger, "setCountry", passengerCountry);
            RposedHelpers.callMethod(passenger, "setEmail", passengerEmail);
            RposedHelpers.callMethod(passenger, "setFirstName", passengerFirstName);
            RposedHelpers.callMethod(passenger, "setIdNo", passengerIdNo);
            RposedHelpers.callMethod(passenger, "setIdType", passengerIdType);
            RposedHelpers.callMethod(passenger, "setLastName", passengerLastName);
            RposedHelpers.callMethod(passenger, "setMobile", passengerMobile);
            RposedHelpers.callMethod(passenger, "setPassType", passengerPassType);
            RposedHelpers.callMethod(passenger, "setSex", passengerSex);

            String desc = (String) RposedHelpers.callStaticMethod(getDescClazz, "getImei", RatelToolKit.sContext);
            Log.i(HookEntry.TAG, "handleRequest desc: " + desc);
            Object createReservationReq = RposedHelpers.newInstance(this.createReservationReqClazz);
            RposedHelpers.callMethod(createReservationReq, "setShoppingCartId", shoppingCartId);
            RposedHelpers.callMethod(createReservationReq, "setDesc", desc);
            RposedHelpers.callMethod(createReservationReq, "setCustomer", customer);
            List<Object> passengerList = new ArrayList<>();
            passengerList.add(passenger);
            RposedHelpers.callMethod(createReservationReq, "setPassengerList", passengerList);

            Log.i(HookEntry.TAG, "handleRequest: " + JSONObject.toJSONString(createReservationReq));

            Object o = Proxy.newProxyInstance(callbackClazz.getClassLoader(), new Class[]{callbackClazz}, new InvocationHandler() {
                @Override
                public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
                    if (method.getName().equals("onRequestSuccess")) {
                        String result = RposedHelpers.getObjectField(args[0], "result");
                        sekiroResponse.success(result);
                    } else if (method.getName().equals("onRequestError")) {
                        sekiroResponse.failed(args[0].toString());
                    }
                    return null;
                }
            });

            RposedHelpers.callMethod(this._rInstance, "getCreateReservation", createReservationReq, o);

        } catch (Throwable throwable) {
            Log.e(HookEntry.TAG, "handleRequest: ", throwable);
        }

    }
}
