package ratel.crack.com.TianjinAirlines.androidApp;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.LayoutInflater;
import android.widget.FrameLayout;

import com.virjar.ratel.api.RatelToolKit;
import com.virjar.ratel.api.rposed.IRposedHookLoadPackage;
import com.virjar.ratel.api.rposed.RC_MethodHook;
import com.virjar.ratel.api.rposed.RposedHelpers;
import com.virjar.ratel.api.rposed.callbacks.RC_LoadPackage;
import com.virjar.sekiro.business.api.ClusterSekiroClient;
import com.virjar.sekiro.business.api.interfaze.HandlerRegistry;
import com.virjar.sekiro.business.api.interfaze.SekiroRequest;
import com.virjar.sekiro.business.api.interfaze.SekiroRequestInitializer;


import java.util.UUID;

/**
 * Created by virjar on 2018/10/6.
 */

public class HookEntry implements IRposedHookLoadPackage {
    public static final String TAG = "TianJingAirLines_HOOK";


    @Override
    public void handleLoadPackage(final RC_LoadPackage.LoadPackageParam lpparam) {
        if (lpparam.processName.equals(lpparam.packageName)) {
            // u 为响应回调接口
            final Class<?> callbackClazz = RposedHelpers.findClass("com.xc.tjhk.base.base.u", RatelToolKit.hostClassLoader);
            // rs 类有查询航班的方法，该对象没有复杂构建过程，可以直接反射创建
            Class<?> rsClazz = RposedHelpers.findClass("rs", RatelToolKit.hostClassLoader);
            final Object rsInstance = RposedHelpers.newInstance(rsClazz);

            // _r 类中有查询下单 id 及创建最终订单的接口，同样 u 为回调接口
            Class<?> _rClazz = RposedHelpers.findClass("_r", RatelToolKit.hostClassLoader);
            final Object _rInstance = RposedHelpers.newInstance(_rClazz);

            final Class<?> itineraryPriceReqClazz = RposedHelpers.findClass("com.xc.tjhk.ui.home.entity.ItineraryPriceReq", RatelToolKit.hostClassLoader);
            final Class<?> createReservationReqClazz = RposedHelpers.findClass("com.xc.tjhk.ui.home.entity.CreateReservationReq", RatelToolKit.hostClassLoader);
            final Class<?> customerBeanClazz = RposedHelpers.findClass("com.xc.tjhk.ui.home.entity.CreateReservationReq$CustomerBean", RatelToolKit.hostClassLoader);
            final Class<?> passengerListBeanClazz = RposedHelpers.findClass("com.xc.tjhk.ui.home.entity.CreateReservationReq$PassengerListBean", RatelToolKit.hostClassLoader);

            final Class<?> getDescClazz = RposedHelpers.findClass("com.eking.sdk.c", RatelToolKit.hostClassLoader);

            new ClusterSekiroClient("TianJinAirLines", UUID.randomUUID().toString())
                    .setupSekiroRequestInitializer(new SekiroRequestInitializer() {
                        @Override
                        public void onSekiroRequest(SekiroRequest sekiroRequest, HandlerRegistry handlerRegistry) {
                            handlerRegistry.registerSekiroHandler(new AirLowSearchHandler(rsInstance, getDescClazz, callbackClazz));
                            handlerRegistry.registerSekiroHandler(new AirItineraryReservationHandler(_rInstance, itineraryPriceReqClazz, callbackClazz));
                            handlerRegistry.registerSekiroHandler(new CreateReservationHandler(_rInstance,
                                    createReservationReqClazz, getDescClazz, customerBeanClazz,
                                    passengerListBeanClazz, callbackClazz));
                        }
                    })
                    .start();
            Log.i(TAG, "handleLoadPackage: start sekiro");
        }


        backup();

        Log.i(TAG, "hook end");
    }


    private void backup() {
        RposedHelpers.findAndHookMethod("com.xc.tjhk.base.utils.a", RatelToolKit.hostClassLoader,
                "decryptAES", String.class, new RC_MethodHook() {
                    @Override
                    protected void afterHookedMethod(MethodHookParam param) throws Throwable {
                        super.afterHookedMethod(param);
                        Log.i(TAG, "decryptAES param: " + param.args[0]);
                        Log.i(TAG, "decryptAES result: " + param.getResult());
                    }
                });
        //            RposedHelpers.findAndHookConstructor("ci", RatelToolKit.hostClassLoader, new RC_MethodHook() {
//                @Override
//                protected void afterHookedMethod(MethodHookParam param) throws Throwable {
//                    super.afterHookedMethod(param);
//                    Log.i(TAG, "afterHookedMethod: ci hooked");
//                    Class<?> _hClass = RposedHelpers.findClass("_h", RatelToolKit.hostClassLoader);
//                    final Object o = RposedHelpers.getObjectField(param.thisObject, "b");
//                    Object o1 = Proxy.newProxyInstance(_hClass.getClassLoader(), new Class[]{_hClass}, new InvocationHandler() {
//                        @Override
//                        public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
//                            Log.i(TAG, "invoke: " + method.getName());
//                            return method.invoke(o, args);
//                        }
//                    });
//
//                    RposedHelpers.setObjectField(param.thisObject, "b", o1);
//
//                }
//            });

    }


}
